// DCGenS.h
#ifndef _DCGENS_H_
#define _DCGENS_H_

#define _EXPR_H_
#define _CONST_H_
#define _VARIABLE_H_
#define _BINEXPR_H_
#define _TERNARYEXPR_H_
#define _MULTIEXPR_H_
#define _ENTRYEXPR_H_
#define _DEBUGOBJECT_H_
#define _EXPRESSION_H_
#define _SYMTAB_H_
#define _EXPRESSIONMISC_H_
#define _EXPRESSIONOBJECT_H_
#define _ERROR_H_
#define _EVAL_H_
#define _UTIL_H_
// redundant
#define _OPTIONS_H_
#define _OPERATORS_H_
#define _PARSER_H_
#define _BUILTIN_H_
//#define _CODEGEN_H_
//#define _GENASM_H_
#define _OPCODE_H_
#define _DEBUG_H_
#define _VERSION_H_
#define _CONSTVAR_H_
#define _DEFS_H_
//
#define toString(a) (a).data.data.stringVal
#define toChar(a) (a).data.data.charVal
#define toInt(a) (a).data.data.intVal
#define toShort(a) (a).data.data.shortVal
#define toLong(a) (a).data.data.longVal
#define toFloat(a) (a).data.data.floatVal
#define toDouble(a) (a).data.data.doubleVal
#define toPtr(a) (a).data.data.ptrVal
#define _COMPAT_H
//
#include "DcGSerror.h"
#include "DCGScompat.h"
#include "DCGSdefs.h"
#include "DCGSconstvar.h"
#include "DCGSEntryExpr.h"
#include "DCGSDebugObject.h"
#include "DCGSsymtab.h"
//#include "DCGSexpression.h"
#include "DCGSexpressionObject.h" 
#include "DCGScodeGen.h"
#include "DCGSgenAsm.h"
#include "DCGSeval.h"
bool deleteExpressionTree(expression *ex);
bool deleteExpression(expression *ex);
class header {
public:
	void *getPgmStart();
	void *getEndBuffer();
	constvar getReturnValue();
	char *getStartBuffer();
	char *getStartBuffer(int line, char *function, char *file);
};
#endif